/*
 *  Copyright © - 2014 Anahata Technologies.
 */
package javase;

//import com.sun.messaging.ConnectionConfiguration;
import static java.lang.StrictMath.*;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.annotation.Resource;
import javax.ejb.EJBContext;
import javax.enterprise.context.ApplicationScoped;
import javax.jms.*;

/**
 *
 * @author Pablo Rodriguez Pina <pablo@anahata-it.com.au>
 */
public class JMSListener {
    private Connection connection;

    private Session session;

    private Topic topic;

    public void init(String topicName) throws Exception {
        long ts = System.currentTimeMillis();
        com.sun.messaging.ConnectionFactory cf = new com.sun.messaging.ConnectionFactory();
        cf.setProperty(ConnectionConfiguration.imqAddressList, "localhost:7676");
        cf.setProperty(ConnectionConfiguration.imqReconnectEnabled, "true");
        connection = cf.createConnection("guest", "guest");
        connection.setExceptionListener(new ExceptionListener() {
            @Override
            public void onException(JMSException exception) {
                System.out.println("exception: " + exception);
            }
        });
        session = connection.createSession(true, Session.SESSION_TRANSACTED);
        topic = session.createTopic(topicName);
        connection.start();
        MessageConsumer messageConsumer = session.createConsumer(topic);
        messageConsumer.setMessageListener(new MessageListener() {
            @Override
            public void onMessage(Message message) {
                try {
                    System.out.println("Got message " + ((TextMessage)message).getText());
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        });
    }

    public static void main(String[] args) throws Exception {
        new JMSListener().init("annotationTopic");
        new JMSListener().init("resourcesTopic");
    }

}
